
/*************************************************************************************************
MatrixKeyboard Keil uVision Plugin

Copyright (C) 2010 Ezequiel Gastn Miravalles

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************************************/

/*************************************************************************************************
Software: MatrixKeyboard Keil uVision Plugin
Author: Ezequiel Gastn Miravalles
Website: http://www.neoegm.com/software/keil-plugins/matrix-keyboard/
License: GNU GPL v3 (attached, read above)
Notes: AGSI library code adapted from Keil supplied samples
*************************************************************************************************/

// MatrixKeyboard.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "MatrixKeyboard.h"
#include "MatrixKeyboardDlg.h"

#include "AGSI.h"
#include "AGSI_ext.h"

#include <direct.h>

#define CONFIG_FILE		"\\MatrixKeyboard.ini"


int Settings_Scan_Ports[4];
int Settings_Scan_Bits[4];

int Settings_Return_Ports[3];
int Settings_Return_Bits[3];


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//
//TODO: If this DLL is dynamically linked against the MFC DLLs,
//		any functions exported from this DLL which call into
//		MFC must have the AFX_MANAGE_STATE macro added at the
//		very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

// CMatrixKeyboardApp

BEGIN_MESSAGE_MAP(CMatrixKeyboardApp, CWinApp)
END_MESSAGE_MAP()


// CMatrixKeyboardApp construction

CMatrixKeyboardApp::CMatrixKeyboardApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


DWORD DefineAllSFR(void) {           // declare all special function registers and their bits
	BOOL ret = TRUE;

	//ret &= Agsi.DefineSFR("ADCCON1",  ADCCON1,  AGSIBYTE, 0);  // If more SFR's are defined, do it in a table
	//ret &= Agsi.DefineSFR("ADCCON2",  ADCCON2,  AGSIBYTE, 0);
	//ret &= Agsi.DefineSFR("ADCCON3",  ADCCON3,  AGSIBYTE, 0);
	//ret &= Agsi.DefineSFR("ADCDATAL", ADCDATAL, AGSIBYTE, 0);
	//ret &= Agsi.DefineSFR("ADCDATAH", ADCDATAH, AGSIBYTE, 0);
	//ret &= Agsi.DefineSFR("DMAL",     DMAL,     AGSIBYTE, 0);
	//ret &= Agsi.DefineSFR("DMAH",     DMAH,     AGSIBYTE, 0);
	//ret &= Agsi.DefineSFR("DMAP",     DMAP,     AGSIBYTE, 0);

	// It is only allowed to define bits which are bitaddressable.
	//ret &= Agsi.DefineSFR("CS0",      ADCCON2,  AGSIBIT,  0);
	//ret &= Agsi.DefineSFR("CS1",      ADCCON2,  AGSIBIT,  1);
	//ret &= Agsi.DefineSFR("CS2",      ADCCON2,  AGSIBIT,  2);
	//ret &= Agsi.DefineSFR("CS3",      ADCCON2,  AGSIBIT,  3);
	//ret &= Agsi.DefineSFR("SCONV",    ADCCON2,  AGSIBIT,  4);
	//ret &= Agsi.DefineSFR("CCNOV",    ADCCON2,  AGSIBIT,  5);
	//ret &= Agsi.DefineSFR("DMA",      ADCCON2,  AGSIBIT,  6);
	//ret &= Agsi.DefineSFR("ADCI",     ADCCON2,  AGSIBIT,  7);

	return(ret);
}


//struct vtrlist VTREG[] = {           // VTR's definition: keep this table consistent with defines in SPeriDLL.h
//	{ "AIN0",   AGSIVTRFLOAT, 0x00000000, NULL },
//	{ "AIN1",   AGSIVTRFLOAT, 0x00000000, NULL },
//	{ "AIN2",   AGSIVTRFLOAT, 0x00000000, NULL },
//	{ "AIN3",   AGSIVTRFLOAT, 0x00000000, NULL },
//	{ "AIN4",   AGSIVTRFLOAT, 0x00000000, NULL },
//	{ "AIN5",   AGSIVTRFLOAT, 0x00000000, NULL },
//	{ "AIN6",   AGSIVTRFLOAT, 0x00000000, NULL },
//	{ "AIN7",   AGSIVTRFLOAT, 0x00000000, NULL },
//	{ "TEMP",   AGSIVTRFLOAT, 0x41C80000, NULL },  // 25 C
//	{ "VREF",   AGSIVTRFLOAT, 0x40200000, NULL },  // 2.5 V
//	{ "XTAL",   AGSIVTRLONG,  0x00A8C000, NULL },  // 11.0592MHz oscillator frequency
//	{ "CONVST", AGSIVTRCHAR,  0x00000001, NULL },
//};

DWORD DefineAllVTREG(void) {         // declare all virtual registers
	BOOL ret = TRUE;
	//int i;

	//for (i = 0; i < (sizeof(VTREG) / sizeof (VTREG[0])); i++) {
	//	VTREG[i].hVTR = Agsi.DefineVTR(VTREG[i].pName, VTREG[i].Type, VTREG[i].Value);
	//	if (!VTREG[i].hVTR) ret = FALSE;
	//}

	return(ret);
}


//AGSIINTERRUPT Interrupt = {     // Table of all Interrupts of this module
//	// vec    *mess           msfr mmask *mname  rsfr     rmask *rname  esfr  emask *ename  p0sfr p0mask *pname p1sfr p1mask pwl auto_reset
//	0x33, "A/D Converter",  0,  0,     "",    ADCCON2, 0x80, "ADCI", IE,   0x40, "EADC", IP,   0x40,  "Pri", 0,    0x00,  7,  1   // ADCI
//};


DWORD DefineAllInterrupts(void) {   // declare all interrupts

	//if (!Agsi.DeclareInterrupt(&Interrupt)) return(FALSE);

	return(TRUE);
}


AGSITIMER Timer;

/*void PortRead()
{
	//if (pCPeriDialog && pCPeriDialog->GetSafeHwnd())
	//{
	//pCPeriDialog->Update();

	//ASSERT(0);

	//pCPeriDialog->GetButtonStates(pButtons);

	DWORD cValue = 0, nValue;

	Agsi.ReadSFR(P1, &cValue, &nValue, 0xFF);

	cValue |= 0xE0;		//Scans = 1

	if (!(cValue & 0x02))	//Scan 0 activa
	{
		if (pButtons[0])
			cValue &=  ~0x20;
		if (pButtons[1])
			cValue &=  ~0x40;
		if (pButtons[2])
			cValue &=  ~0x80;
	}

	if (!(cValue & 0x04))	//Scan 1 activa
	{
		if (pButtons[3])
			cValue &=  ~0x20;
		if (pButtons[4])
			cValue &=  ~0x40;
		if (pButtons[5])
			cValue &=  ~0x80;
	}

	if (!(cValue & 0x08))	//Scan 2 activa
	{
		if (pButtons[6])
			cValue &=  ~0x20;
		if (pButtons[7])
			cValue &=  ~0x40;
		if (pButtons[8])
			cValue &=  ~0x80;
	}

	if (!(cValue & 0x10))	//Scan 3 activa
	{
		if (pButtons[9])
			cValue &=  ~0x20;
		if (pButtons[10])
			cValue &=  ~0x40;
		if (pButtons[11])
			cValue &=  ~0x80;
	}

	//Agsi.SetSFRReadValue(cValue);
	//Agsi.SetSFRReadValue(0);
	Agsi.WriteSFR(P1, cValue, 0xFF);

	//0		1		2
	//3		4		5
	//6		7		8
	//9		10		11
	//}
}*/

void PortRead()
{
	DWORD cValue = 0, nValue;

	unsigned char ScanValues[4] = {0};
	unsigned char ReturnValues[3] = {1, 1, 1};	//Returns = 1

	for (int i = 0; i < 4; i++)
	{
		Agsi.ReadSFR(Settings_Scan_Ports[i], &cValue, &nValue, 0x01 << Settings_Scan_Bits[i]);
		ScanValues[i] = (cValue?1:0);
	}

	for (int i = 0; i < 4; i++)
		if (!ScanValues[i])	//Scan activa
			for (int j = 0; j < 3; j++)
				if (pButtons[i*3+j])
					ReturnValues[j] = 0;


	for (int i = 0; i < 3; i++)	//Write returns
		Agsi.WriteSFR(Settings_Return_Ports[i], ReturnValues[i] << Settings_Return_Bits[i], 0x01 << Settings_Return_Bits[i]);

	//0		1		2
	//3		4		5
	//6		7		8
	//9		10		11
}

DWORD DefineAllWatches(void) {      // define all Watches
	BOOL ret = TRUE;

	//ret &= Agsi.SetWatchOnSFR(ADCCON1, AdcConv, AGSIWRITE);
	//ret &= Agsi.SetWatchOnSFR(ADCCON2, AdcConv, AGSIWRITE);
	//ret &= Agsi.SetWatchOnSFR(ADCCON3, AdcConv, AGSIWRITE);
	//ret &= Agsi.SetWatchOnVTR(CONVST,  AdcConv, AGSIWRITE);

	for (int i = 0; i < 4; i++)
		Agsi.SetWatchOnSFR(Settings_Scan_Ports[i], PortRead, AGSIREAD);

	//Timer = Agsi.CreateTimer(AdcCompleted);
	//if (!Timer) return(FALSE);

	return(ret);
}


DWORD DefineAllMenuEntries(void) {  // declare all peripheral-menu entries and dialogs

	if (!Agsi.DefineMenuItem(&PeriMenu)) return(FALSE);

	return(TRUE);
}


DWORD ResetPeripheral(void) {       // reset all SFR's of this peripheral
	BOOL ret = TRUE;

	//ret &= Agsi.WriteSFR(ADCCON1,  0x20, 0xFF);
	//ret &= Agsi.WriteSFR(ADCCON2,  0x00, 0xFF);
	//ret &= Agsi.WriteSFR(ADCCON3,  0x00, 0xFF);
	//ret &= Agsi.WriteSFR(ADCDATAL, 0x00, 0xFF);
	//ret &= Agsi.WriteSFR(ADCDATAH, 0x00, 0xFF);
	//ret &= Agsi.WriteSFR(DMAL,     0x00, 0xFF);
	//ret &= Agsi.WriteSFR(DMAH,     0x00, 0xFF);
	//ret &= Agsi.WriteSFR(DMAP,     0x00, 0xFF);

	return(ret);
}

int ReadSetting(const char *pszField, int nIndex, bool bHex)
{
	char pszPath[256];
	_getcwd(pszPath, 256);
	strcat_s(pszPath, CONFIG_FILE);

	char pszBuffer[128];
	sprintf_s(pszBuffer, pszField, nIndex);

	char pszValue[64];
	GetPrivateProfileString("Settings", pszBuffer, "", pszValue, 63, pszPath);

	//MessageBox(NULL, pszValue, pszBuffer, MB_OK);

	return (int)strtoul(pszValue, NULL, bHex?16:10);
}

BOOL ReadSettings()
{
	//char pszTmp[64];

	for (int i = 0; i < 4; i++)
	{
		Settings_Scan_Ports[i] = ReadSetting("Scan%d_Port_Address", i, true);

		//itoa(Settings_Scan_Ports[i], pszTmp, 10);
		//MessageBox(NULL, pszTmp, "Address", MB_OK);

		Settings_Scan_Bits[i] = ReadSetting("Scan%d_Port_Bit", i, false);
	}

	for (int i = 0; i < 3; i++)
	{
		Settings_Return_Ports[i] = ReadSetting("Return%d_Port_Address", i, true);

		//itoa(Settings_Scan_Ports[i], pszTmp, 10);
		//MessageBox(NULL, pszTmp, "Address", MB_OK);

		Settings_Return_Bits[i] = ReadSetting("Return%d_Port_Bit", i, false);
	}

	return TRUE;
}

extern "C" DWORD AGSIEXPORT AgsiEntry (DWORD nCode, void *vp) {
	DWORD CpuType;

	switch (nCode) {
	case AGSI_CHECK:
		CpuType = *((DWORD *)vp);
		if (CpuType == 8051) return(1);  // This driver supports the 8051 family of microcontrollers 
		else                 return(0);  // Other microcontrollers are not supported by the driver
		break;

	case AGSI_INIT:                    // Declare all SFR's, VTREG's, Watches and Interrupts here
		AgsiConfig = *((AGSICONFIG *)vp);
		//    AgsiConfig.m_hInstance;          // this pointer is used to get the function addresses of uVision
		//    AgsiConfig.m_pszProjectPath;     // Path to application e.g. C:\KEIL\C51\EXAMPLES\HELLO
		//    AgsiConfig.m_pszDevice;          // Simulated Device e.g. 52. This string is extracted out of the -p option.
		//    AgsiConfig.m_pszConfiguration;   // complete dialog DLL options e.g. -p52 -dmydll ...
		//    AgsiConfig.m_pszAppFile;         // name of loaded OMF file including path e.g. C:\KEIL\C51\EXAMPLES\HELLO\HELLO

		if (!ReadSettings()) return(FALSE);

		if (!GetFunctionPointers()) return(FALSE);   // get all function pointers for Agsi calls
		if (!DefineAllSFR()) return(FALSE);          // define all special function registers
		if (!DefineAllVTREG()) return(FALSE);        // define all virtual registers
		if (!DefineAllInterrupts()) return(FALSE);   // define all interrupts
		if (!DefineAllWatches()) return(FALSE);      // define all watches
		if (!DefineAllMenuEntries()) return(FALSE);  // define all peripheral-menu entries and dialogs
		break;

	case AGSI_TERMINATE:               // Free all allocated memory, close all files ...
		break;

	case AGSI_RESET:                   // Reset all SFR's of this peripheral
		if (!ResetPeripheral()) return(FALSE);
		break;

	case AGSI_PREPLL:                  // Recalculate all peripherals before clock prescaler/PLL is set to a new value
		break;

	case AGSI_POSTPLL:                 // Recalculate all peripherals after clock prescaler/PLL is set to a new value
		break;
	}
	return(TRUE);       // return OK
}


// The one and only CMatrixKeyboardApp object

CMatrixKeyboardApp theApp;


// CMatrixKeyboardApp initialization

BOOL CMatrixKeyboardApp::InitInstance()
{
	CWinApp::InitInstance();

	return TRUE;
}
