
/*************************************************************************************************
MatrixKeyboard Keil uVision Plugin

Copyright (C) 2010 Ezequiel Gastn Miravalles

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************************************/

/*************************************************************************************************
Software: MatrixKeyboard Keil uVision Plugin
Author: Ezequiel Gastn Miravalles
Website: http://www.neoegm.com/software/keil-plugins/matrix-keyboard/
License: GNU GPL v3 (attached, read above)
Notes: AGSI library code adapted from Keil supplied samples
*************************************************************************************************/

// MatrixKeyboardDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MatrixKeyboard.h"
#include "MatrixKeyboardDlg.h"
#include "AGSI_ext.h"


// CMatrixKeyboardDlg dialog
static void PeriUpdate (void);
static void PeriKill   (AGSIDLGD *pM);
static void PeriDisp   (AGSIMENU *pM);

BOOL pButtons[12] = {0};

CMatrixKeyboardDlg *pCPeriDialog = NULL;
BYTE initflag = 0;

// must not use 'const' here !
//                     iOpen  Hwnd   Dlg Proc.  Rect: -1 := default    Update       Kill
AGSIDLGD PeriDlg =  {    0,   NULL,      NULL,  { -1, -1, -1, -1, },  PeriUpdate,  PeriKill };

//                    nDelim   *szText            *fp      nID   nDlgId         *pDlg;
AGSIMENU PeriMenu =  {  1,   "&Matrix Keyboard"  , PeriDisp,  0,  IDD_MATRIX_KEYBOARD,     &PeriDlg   };  // Peripheral Dialog

//IMPLEMENT_DYNAMIC(CMatrixKeyboardDlg, CDialog)

static void PeriUpdate (void)  {            // Update Function
	if (pCPeriDialog) pCPeriDialog->Update();
}

static void PeriKill (AGSIDLGD *pM)  {      // Kill Function
	if (pCPeriDialog == NULL) return;
	pCPeriDialog->SendMessage (WM_CLOSE);
	pCPeriDialog  = NULL;
	pM->iOpen = 0;
	pM->hw    = NULL;
}

static void PeriDisp (AGSIMENU *pM)  {
	if (pM->pDlg->hw != NULL)  {              // created
		PeriKill (pM->pDlg);                    // close
	} else  {
		    AFX_MANAGE_STATE(AfxGetStaticModuleState());// -- not necessary.
		pCPeriDialog = new CMatrixKeyboardDlg (pM, NULL);     // modeless construction
		if (pCPeriDialog != NULL)  {                   // construction was Ok.
			pM->pDlg->hw = pCPeriDialog->m_hWnd;         // Dialog handle
		}
	}
}

CMatrixKeyboardDlg::CMatrixKeyboardDlg (AGSIMENU *pMen, CWnd *pWnd)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState( ));
	pM = pMen;                     // save DYM-Descriptor locally.
	Create (IDD_MATRIX_KEYBOARD, pWnd);
	pCPeriDialog = this;

	for (int i = 0; i < CANT_BUTTONS; i++)
		m_pButtons[i] = FALSE;
}

CMatrixKeyboardDlg::~CMatrixKeyboardDlg()
{
}

void CMatrixKeyboardDlg::DoDataExchange(CDataExchange* pDX)
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CDialog::DoDataExchange(pDX);
	//DDX_Check(pDX, IDC_CHECK1, m_pButtons[0]);
	//DDX_Check(pDX, IDC_CHECK2, m_pButtons[2]);
	//DDX_Check(pDX, IDC_CHECK3, m_pButtons[3]);
	//DDX_Check(pDX, IDC_CHECK4, m_pButtons[4]);
	//DDX_Check(pDX, IDC_CHECK5, m_pButtons[5]);
	//DDX_Check(pDX, IDC_CHECK6, m_pButtons[6]);
	//DDX_Check(pDX, IDC_CHECK7, m_pButtons[7]);
	//DDX_Check(pDX, IDC_CHECK8, m_pButtons[8]);
	//DDX_Check(pDX, IDC_CHECK9, m_pButtons[9]);
	//DDX_Check(pDX, IDC_CHECK10, m_pButtons[10]);
	//DDX_Check(pDX, IDC_CHECK11, m_pButtons[11]);
	//DDX_Check(pDX, IDC_CHECK12, m_pButtons[12]);
}


BEGIN_MESSAGE_MAP(CMatrixKeyboardDlg, CDialog)
//	ON_BN_CLICKED(IDC_BUTTON1, &CMatrixKeyboardDlg::OnBnClickedButton1)
	ON_WM_ACTIVATE()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_CHECK1, &CMatrixKeyboardDlg::OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_CHECK2, &CMatrixKeyboardDlg::OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_CHECK3, &CMatrixKeyboardDlg::OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_CHECK4, &CMatrixKeyboardDlg::OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_CHECK5, &CMatrixKeyboardDlg::OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_CHECK6, &CMatrixKeyboardDlg::OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_CHECK7, &CMatrixKeyboardDlg::OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_CHECK8, &CMatrixKeyboardDlg::OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_CHECK9, &CMatrixKeyboardDlg::OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_CHECK10, &CMatrixKeyboardDlg::OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_CHECK11, &CMatrixKeyboardDlg::OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_CHECK12, &CMatrixKeyboardDlg::OnBnClickedCheck1)
END_MESSAGE_MAP()


// CMatrixKeyboardDlg message handlers

//void CMatrixKeyboardDlg::OnBnClickedButton1()
//{
//	#define P2 0x90
//	DWORD cP0, pP0;
//	Agsi.ReadSFR(P2, &cP0, &pP0, 0xFF);
//
//	char pszStr[64];
//
//	sprintf(pszStr, "0x%X", cP0);
//
//	MessageBox(pszStr);
//
//	Agsi.WriteSFR(P2, 0xFF, 0xFF);
//}

void CMatrixKeyboardDlg::GetButtonStates(BOOL pButtons[])
{
	pButtons[0] = ((CButton*)GetDlgItem(IDC_CHECK1))->GetCheck();
	pButtons[1] = ((CButton*)GetDlgItem(IDC_CHECK2))->GetCheck();
	pButtons[2] = ((CButton*)GetDlgItem(IDC_CHECK3))->GetCheck();
	pButtons[3] = ((CButton*)GetDlgItem(IDC_CHECK4))->GetCheck();
	pButtons[4] = ((CButton*)GetDlgItem(IDC_CHECK5))->GetCheck();
	pButtons[5] = ((CButton*)GetDlgItem(IDC_CHECK6))->GetCheck();
	pButtons[6] = ((CButton*)GetDlgItem(IDC_CHECK7))->GetCheck();
	pButtons[7] = ((CButton*)GetDlgItem(IDC_CHECK8))->GetCheck();
	pButtons[8] = ((CButton*)GetDlgItem(IDC_CHECK9))->GetCheck();
	pButtons[9] = ((CButton*)GetDlgItem(IDC_CHECK10))->GetCheck();
	pButtons[10] = ((CButton*)GetDlgItem(IDC_CHECK11))->GetCheck();
	pButtons[11] = ((CButton*)GetDlgItem(IDC_CHECK12))->GetCheck();
}

void CMatrixKeyboardDlg::Update()
{
	//AFX_MANAGE_STATE(AfxGetStaticModuleState());

	//UpdateData(TRUE);

	//m_pButtons[0] = ((CButton*)GetDlgItem(IDC_CHECK1))->GetCheck();
	//m_pButtons[1] = ((CButton*)GetDlgItem(IDC_CHECK2))->GetCheck();
	//m_pButtons[2] = ((CButton*)GetDlgItem(IDC_CHECK3))->GetCheck();
	//m_pButtons[3] = ((CButton*)GetDlgItem(IDC_CHECK4))->GetCheck();
	//m_pButtons[4] = ((CButton*)GetDlgItem(IDC_CHECK5))->GetCheck();
	//m_pButtons[5] = ((CButton*)GetDlgItem(IDC_CHECK6))->GetCheck();
	//m_pButtons[6] = ((CButton*)GetDlgItem(IDC_CHECK7))->GetCheck();
	//m_pButtons[7] = ((CButton*)GetDlgItem(IDC_CHECK8))->GetCheck();
	//m_pButtons[8] = ((CButton*)GetDlgItem(IDC_CHECK9))->GetCheck();
	//m_pButtons[9] = ((CButton*)GetDlgItem(IDC_CHECK10))->GetCheck();
	//m_pButtons[10] = ((CButton*)GetDlgItem(IDC_CHECK11))->GetCheck();
	//m_pButtons[11] = ((CButton*)GetDlgItem(IDC_CHECK12))->GetCheck();
}

void CMatrixKeyboardDlg::PostNcDestroy()
{
	delete this;              // delete the new'ed object
	pCPeriDialog = NULL;      // clear external Object pointer here.

	//CDialog::PostNcDestroy();
}

BOOL CMatrixKeyboardDlg::OnInitDialog()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CDialog::OnInitDialog();

	// Restore Position (Only moving without resizing)
	if (PeriDlg.rc.left != -1) {
		SetWindowPos(NULL,                        /* placement order - not used */
			PeriDlg.rc.left,             /* left */
			PeriDlg.rc.top,              /* top  */
			0,                           /* width - not used */
			0,                           /* height - not used */
			SWP_NOSIZE | SWP_NOZORDER);  /* flags */
	}

	initflag = 1;
	Update();
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CMatrixKeyboardDlg::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized)
{
	CDialog::OnActivate(nState, pWndOther, bMinimized);

	switch (nState)  {
	case WA_INACTIVE:
		Agsi.HandleFocus(NULL);      // Clear Modeless Handle
		break;
	case WA_ACTIVE:
	case WA_CLICKACTIVE:
		Agsi.HandleFocus(m_hWnd);    // Set Modeless Handle
		break;
	}
}

void CMatrixKeyboardDlg::OnClose()
{
	GetWindowRect (&pM->pDlg->rc);  // save Window position
	pM->pDlg->hw = NULL;            // clear m_hWnd
	DestroyWindow();                //--- modeless

	//CDialog::OnClose();
}

void CMatrixKeyboardDlg::OnOK() {

	//	CDialog::OnOK();  // Do nothing when <Enter> is pressed
}

void CMatrixKeyboardDlg::OnCancel() {

	OnClose();            // Close Dialog when <ESC> is pressed 
}

void CMatrixKeyboardDlg::OnBnClickedCheck1()
{
	GetButtonStates(pButtons);
}
